/******************************************************************************
 *	File	:	EcmUsrDriver.h
 *	Version :	1.1
 *	Date	:	2021/01/26
 *	Author	:	XFORCE
 *
 *	ECM-XF basic driver example - Header file
 *
 *	Demonstrate how to implement API type user driver
 *
 * @copyright (C) 2020 NEXTW TECHNOLOGY CO., LTD.. All rights reserved.
 *
 ******************************************************************************/
#include "EcmUsrDriver.h"
#include "EcmAdcDriver.h"

extern SPI_CMD_PACKAGE_T *pCmd;
extern SPI_RET_PACKAGE_T *pRet;
extern uint8_t u8CmdIdx;

int ECM_AdcOpen( uint32_t mode)
{
	int i=0;
	uint8_t IdxCheck;
    if(mode > 1)
        return -1;
	pCmd->Head.u8Cmd = ECM_ADC_FUNC_OP;
	pCmd->Head.u8Param = 40;
	pCmd->Head.u16Size = 4;
    pCmd->Data[0] = 0;
    pCmd->Data[1] = mode;
    pCmd->Data[2] = 0;
    pCmd->Data[3] = 0;
	pCmd->Head.u8Idx = u8CmdIdx++;
	for(i=0;i<100;i++){
		if(SpiDataExchange(&IdxCheck, 0)){
			if(pCmd->Head.u8Idx == IdxCheck){
				return 1;
			}
		}
	}
	return 0;
}

int ECM_AdcClose(void)
{
	int i=0;
	uint8_t IdxCheck;
	pCmd->Head.u8Cmd = ECM_ADC_FUNC_OP;
	pCmd->Head.u8Param = 41;
	pCmd->Head.u16Size = 0;
	pCmd->Head.u8Idx = u8CmdIdx++;
	for(i=0;i<100;i++){
		if(SpiDataExchange(&IdxCheck, 0)){
			if(pCmd->Head.u8Idx == IdxCheck){
				return 1;
			}
		}
	}
	return 0;
}

int ECM_AdcConfigSampleModule( uint32_t source){
	int i;
	uint8_t IdxCheck;
	pCmd->Head.u8Cmd = ECM_ADC_FUNC_OP;
	pCmd->Head.u8Param = 42;
	pCmd->Head.u16Size = 12;
    i = 12;
	memcpy( pCmd->Data, &i, sizeof(uint32_t));
	memcpy( pCmd->Data+4, &source, sizeof(uint32_t));
	memcpy( pCmd->Data+8, &i, sizeof(uint32_t));
	pCmd->Head.u8Idx = u8CmdIdx++;
	for(i=0;i<100;i++){
		if(SpiDataExchange(&IdxCheck, 0)){
			if(pCmd->Head.u8Idx == IdxCheck){
				return 1;
			}
		}
	}
	return 0;
}

int ECM_AdcGetDataValidFlag(uint32_t *flag){
	uint32_t i;
	uint8_t IdxCheck;
	pCmd->Head.u8Cmd = ECM_ADC_FUNC_OP;
	pCmd->Head.u8Param = 17;
	pCmd->Head.u16Size = 4;
	pCmd->Head.u8Idx = u8CmdIdx++;
	i = 1 << 12;
	memcpy( pCmd->Data, &i, sizeof(uint32_t));
	for(i=0;i<100;i++){
		if(SpiDataExchange(&IdxCheck, 0)){
			if(pCmd->Head.u8Idx == IdxCheck){
				memcpy( flag, pRet->Data, sizeof(uint32_t));
				return 1;
			}
		}
	}
	return 0;
}

int ECM_AdcStartConv(void)
{
	uint32_t i=0;
	uint8_t IdxCheck;
	pCmd->Head.u8Cmd = ECM_ADC_FUNC_OP;
	pCmd->Head.u8Param = 12;
	pCmd->Head.u16Size = 4;
	pCmd->Head.u8Idx = u8CmdIdx++;
	i = 1 << 12;
	memcpy( pCmd->Data, &i, sizeof(uint32_t));
	for(i=0;i<100;i++){
		if(SpiDataExchange(&IdxCheck, 0)){
			if(pCmd->Head.u8Idx == IdxCheck){
				return 1;
			}
		}
	}
	return 0;
}

int ECM_AdcGetConvData( uint32_t *data){
	uint32_t i;
	uint8_t IdxCheck;
	pCmd->Head.u8Cmd = ECM_ADC_FUNC_OP;
	pCmd->Head.u8Param = 15;
	pCmd->Head.u16Size = 4;
	pCmd->Head.u8Idx = u8CmdIdx++;
    i = 12;
	memcpy( pCmd->Data, &i, sizeof(uint32_t));
	for(i=0;i<100;i++){
		if(SpiDataExchange(&IdxCheck, 0)){
			if(pCmd->Head.u8Idx == IdxCheck){
				memcpy( data, pRet->Data, sizeof(uint32_t));
				return 1;
			}
		}
	}
	return 0;
}
