/******************************************************************************
 *	File	:	EcmUsrDriver.h
 *	Version :	1.1
 *	Date	:	2021/01/26
 *	Author	:	XFORCE
 *
 *	ECM-XF basic driver example - Header file
 *
 *	Demonstrate how to implement API type user driver
 *
 * @copyright (C) 2020 NEXTW TECHNOLOGY CO., LTD.. All rights reserved.
 *
 ******************************************************************************/#include "EcmUsrDriver.h"
#include "EcmEncDriver.h"

extern SPI_CMD_PACKAGE_T *pCmd;
extern SPI_RET_PACKAGE_T *pRet;
extern uint8_t u8CmdIdx;

int ECM_EncOpen( uint8_t mode)
{
	int i=0;
	uint8_t IdxCheck;
    if(mode > 3)
        return -1;
	pCmd->Head.u8Cmd = ECM_QEI_FUNC_OP;
	pCmd->Head.u8Param = 4;
	pCmd->Head.u16Size = 4;
	pCmd->Data[0] = pCmd->Data[2] = pCmd->Data[3] = 0;
	pCmd->Data[1] = mode;
	pCmd->Head.u8Idx = u8CmdIdx++;
	for(i=0;i<100;i++){
		if(SpiDataExchange(&IdxCheck, 0)){
			if(pCmd->Head.u8Idx == IdxCheck){
				return 1;
			}
		}
	}
	return 0;
}

int ECM_EncStart(void)
{
	int i=0;
	uint8_t IdxCheck;
	pCmd->Head.u8Cmd = ECM_QEI_FUNC_OP;
	pCmd->Head.u8Param = 5;
	pCmd->Head.u16Size = 0;
	pCmd->Head.u8Idx = u8CmdIdx++;
	for(i=0;i<100;i++){
		if(SpiDataExchange(&IdxCheck, 0)){
			if(pCmd->Head.u8Idx == IdxCheck){
				return 1;
			}
		}
	}
	return 0;
}

int ECM_EncStop(void)
{
	int i=0;
	uint8_t IdxCheck;
	pCmd->Head.u8Cmd = ECM_QEI_FUNC_OP;
	pCmd->Head.u8Param = 6;
	pCmd->Head.u16Size = 0;
	pCmd->Head.u8Idx = u8CmdIdx++;
	for(i=0;i<100;i++){
		if(SpiDataExchange(&IdxCheck, 0)){
			if(pCmd->Head.u8Idx == IdxCheck){
				return 1;
			}
		}
	}
	return 0;
}

int ECM_EncGetCount( uint32_t *count)
{
	int i=0;
	uint8_t IdxCheck;
	if(!count)
		return -1;
	pCmd->Head.u8Cmd = ECM_QEI_FUNC_OP;
	pCmd->Head.u8Param = 21;
	pCmd->Head.u16Size = 0;
	pCmd->Head.u8Idx = u8CmdIdx++;
	for(i=0;i<100;i++){
		if(SpiDataExchange(&IdxCheck, 0)){
			if(pCmd->Head.u8Idx == IdxCheck){
				memcpy( count, pRet->Data, sizeof(uint32_t));
				return 1;
			}
		}
	}
	return 0;
}
